//
//  MyWebService.m
//  ClassWebService
//
//  Created by Administrator on 7/31/13.
//  Copyright (c) 2013 Administrator. All rights reserved.
//

#import "MyWebService.h"

@implementation MyWebService

- (id) init
{
    self = [super init];
    return (self);
}

- (id) initService:(NSString *)_url :(NSMutableDictionary *)data;
{
    NSError             *error;
    
    if ((self = [self init]) == nil)
        return (nil);
    self->url = [[NSString alloc] initWithString:_url];
    error = nil;
    if (data != nil)
    {
        self->request_data = [NSJSONSerialization
                              dataWithJSONObject:data
                              options:kNilOptions
                              error:&error];
    }
    if (error != nil)
    {
        NSLog(@"Error = %@", error);
        return (nil);
    }
    if ((self->request = [NSMutableURLRequest
                          requestWithURL:[NSURL URLWithString:_url]]) == nil)
        return (nil);
    return (self);
}

- (NSString *) getWebService:(NSString *)type_request
{
    NSData              *response_data;
    NSURLResponse       *response_url;
    NSError             *error;

    if (self->request == nil)
        return (nil);
    error = nil;
    response_url = nil;
    self->response = nil;
    [self->request setHTTPMethod:type_request];
    [self->request setValue:@"application/json" forHTTPHeaderField:@"Content-Type"];
    [self->request setValue:[NSString stringWithFormat:@"%ld",
                             (unsigned long)[self->request_data length]]
                                forHTTPHeaderField:@"Content-Length"];
    [request setHTTPBody:self->request_data];
    response_data = [NSURLConnection sendSynchronousRequest:
                     request returningResponse:&response_url
                                                      error:&error];
    if (response_data == nil || error != nil)
    {
        if (error != nil)
            NSLog(@"Error = %@", error);
        return (nil);
    }
    self->response = [[NSString alloc] initWithData:
                      response_data encoding:NSUTF8StringEncoding];
    NSLog(@"response = %@", self->response);
    return (self->response);
}

- (NSString *)  parseResponse:(NSString *)key
{
    char        **tab;
    int         i;
    int         size;
    
    if (self->response == nil ||
        (tab = wordtab((char *)[self->response UTF8String], ",{}\"")) == NULL)
        return (nil);
    i = 0;
    size = size_tab(tab);
    i = 0;
    while (i + 3 < size && tab[i] != NULL) {
        if (strcmp(tab[i], [key UTF8String]) == 0)
            return ([NSString stringWithUTF8String:tab[(i + 2) % size]]);
        i += 3;
    }
    return (nil);
}

@end
