//
//  ViewController.m
//  tryClassWebService
//
//  Created by Administrator on 7/31/13.
//  Copyright (c) 2013 Administrator. All rights reserved.
//

#import "ViewController.h"
#import "MyWebService.h"

# define URL_STRING_CONNECT @"http://core.mirror7.com.br/Mirror7/authenticate"
# define URL_STRING_LOGOUT @"http://core.mirror7.com.br/Mirror7/logout"

@interface ViewController ()
{
    BOOL        is_connected;
    NSString    *token;
}

@end

@implementation ViewController

- (void) touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event
{
    [[self view] endEditing:YES];
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    is_connected = NO;
    _logout.hidden = YES;
    _status.textColor = [UIColor redColor];
    _status.text = @"Disconnected";
    token = nil;
	// Do any additional setup after loading the view, typically from a nib.
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (void)viewDidUnload {
    [self setLogin:nil];
    [self setPassword:nil];
    [self setConnect:nil];
    [self setLogout:nil];
    [self setStatus:nil];
    [super viewDidUnload];
}
- (IBAction)connect:(id)sender {
    MyWebService        *serv;
    NSMutableDictionary *data;
    NSString            *err;
    
    token = nil;
    [[self view] endEditing:YES];
    data = [[NSMutableDictionary alloc] init];
    [data setObject:_login.text forKey:@"login"];
    [data setObject:_password.text forKey:@"pwd"];
    [data setObject:@"iPhone Simulator" forKey:@"bind"];
    [data setObject:@"/" forKey:@"bindPath"];
    [data setObject:@"IOS" forKey:@"osName"];
    if ((serv = [[MyWebService alloc] initService:URL_STRING_CONNECT :data]) == nil)
    {
        NSLog(@"Error init");
        return ;
    }
    [serv getWebService:@"POST"];
    token = [serv parseResponse:@"token"];
    err = [serv parseResponse:@"errorMessage"];
    if (token == nil || err != nil)
    {
        _status.textColor = [UIColor redColor];
        _status.text = [NSString stringWithFormat:@"Error = %@", err];
        return ;
    }
    else
    {
        _status.textColor = [UIColor greenColor];
        _status.text = [NSString stringWithFormat:@"Connected : %@", _login.text];
        is_connected = YES;
        _connect.hidden = YES;
        _logout.hidden = NO;
    }
}

- (IBAction)logout:(id)sender {
    MyWebService        *serv;
    NSString            *err;
    
    [[self view] endEditing:YES];
    if ((serv = [[MyWebService alloc] initService:
                 [NSString stringWithFormat:@"%@/%@",
                  URL_STRING_LOGOUT, token] :nil]) == nil)
    {
        NSLog(@"Error init");
        return ;
    }
    [serv getWebService:@"GET"];
    err = [serv parseResponse:@"errorMessage"];
    if (err != nil)
    {
        _status.text = [NSString stringWithFormat:@"Error = %@", err];
        return ;
    }
    else
    {
        _login.text = nil;
        _password.text = nil;
        _status.textColor = [UIColor redColor];
        _status.text = @"Disconnected";
        is_connected = NO;
        _connect.hidden = NO;
        _logout.hidden = YES;
    }
}
@end
